# hippo-book




## docker安装使用

1. 下载docker image  docker pull fellah/gitbook
1. 进入项目根目录下，运行gitbook容器命令
  ```
   docker rm gitbook
  ```

  ```
    docker run --name gitbook \
    -p 4000:4000  \
    -v $(pwd):/srv/gitbook \
    -v $(pwd)/.html:/srv/html \
    fellah/gitbook
  ```
说明
- /srv/gitbook 是gitbook工作目录，用来存放源文件，映射到了本地的/home/woods/gitbook/gitbook
- /srv/html 是构建后的html文件，可在WEB服务中查看，映射到了本地的/home/woods/gitbook/html
- 请确保本地的gitbook目录中包含至少README.md和SUMMARY.md两个文件
1. 访问：http://localhost:4000/

1. 重新构建命令
```
docker exec gitbook gitbook build . /srv/html
```



## 自动生成SUMMARY

[imfly](https://github.com/imfly)/**gitbook-summary**

github地址：https://github.com/imfly/gitbook-summary

安装

```css
npm install -g gitbook-summary
```

简单使用：

```bash
cd /path/to/your/book/



book sm
```

